Attribute VB_Name = "modLoxBuster"
Option Explicit

Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Public Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Public Declare Function IsWindowEnabled Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function IsWindowVisible Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Public Declare Function SendMessageLong& Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function timeGetTime Lib "winmm.dll" () As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Public Const HWND_NOTOPMOST = -2
Public Const HWND_TOPMOST = -1

Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1

Public Const VK_RETURN = &HD
Public Const VK_SPACE = &H20

Public Const WM_CHAR = &H102
Public Const WM_CLOSE = &H10
Public Const WM_KEYDOWN = &H100
Public Const WM_KEYUP = &H101
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_MOVE = &HF012
Public Const WM_SETTEXT = &HC
Public Const WM_SYSCOMMAND = &H112

Public Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE

Public Sub ClickButton(hWnd As Long)
    Call PostMessage(hWnd, WM_KEYDOWN, VK_SPACE, 0)
    Call PostMessage(hWnd, WM_KEYUP, VK_SPACE, 0)
End Sub

Public Sub ClickIcon(hWnd As Long)
    Call SendMessage(hWnd, WM_LBUTTONDOWN, 0, 0)
    Call SendMessage(hWnd, WM_LBUTTONUP, 0, 0)
End Sub

Public Function Find32770(Optional Caption As String = "America Online", Optional Kill As Boolean = False) As Long
    Dim Window As Long
    Window = FindWindow("#32770", Caption)
    Find32770 = Window
    If Kill And Find32770 <> 0 Then
        Dim WindowButton As Long
        WindowButton = FindWindowEx(Window, 0, "Button", "OK")
        Do
            DoEvents
            Call ClickButton(WindowButton)
            Window = FindWindow("#32770", Caption)
        Loop Until Window = 0
    End If
End Function

Public Function FindAOLChild(Optional SecondHWND As Long = 0, Optional Caption As String = vbNullString) As Long
    FindAOLChild = FindWindowEx(FindMDIClient, SecondHWND, "AOL Child", Caption)
End Function

Public Function FindDownloadManager(Optional Download As Boolean = False, Optional RemoveItem As Boolean = False) As Long
    Dim AOLChild As Long
    Dim AOLIcon(1) As Long
    Dim Window As Long
    Dim WindowButton As Long
    AOLChild = FindAOLChild(, "Download Manager")
    AOLIcon(0) = FindWindowEx(AOLChild, 0, "_AOL_Icon", vbNullString)
    AOLIcon(0) = FindWindowEx(AOLChild, AOLIcon(0), "_AOL_Icon", vbNullString)
    AOLIcon(1) = FindWindowEx(AOLChild, AOLIcon(0), "_AOL_Icon", vbNullString)
    AOLIcon(1) = FindWindowEx(AOLChild, AOLIcon(1), "_AOL_Icon", vbNullString)
    FindDownloadManager = AOLChild
    If Download Then
        Call ClickIcon(AOLIcon(0))
    End If
    If RemoveItem Then
        Call ClickIcon(AOLIcon(1))
        Do
            DoEvents
            Window = Find32770("America Online")
            WindowButton = FindWindowEx(Window, 0, "Button", "&Yes")
        Loop Until WindowButton <> 0 And IsWindowVisible(WindowButton) = 1 And IsWindowEnabled(WindowButton) = 1
        Do
            DoEvents
            Call ClickButton(WindowButton)
            Window = Find32770("America Online")
        Loop Until Window = 0
    End If
End Function

Public Function FindMDIClient() As Long
    FindMDIClient = FindWindow("AOL Frame25", vbNullString)
    FindMDIClient = FindWindowEx(FindMDIClient, 0, "MDIClient", vbNullString)
End Function

Public Function FindModal(Optional Kill As Boolean = False, Optional Caption As String = vbNullString) As Long
    Dim AOLChild As Long
    Dim AOLIcon As Long
    AOLChild = FindWindow("_AOL_Modal", Caption)
    FindModal = AOLChild
    If Kill And AOLChild <> 0 Then
        Do
            DoEvents
            AOLIcon = FindWindowEx(AOLChild, 0, "_AOL_Icon", vbNullString)
        Loop Until AOLIcon <> 0 And IsWindowVisible(AOLIcon) = 1 And IsWindowEnabled(AOLIcon) = 1
        Do
            DoEvents
            Call ClickIcon(AOLIcon)
            AOLChild = FindWindow("_AOL_Modal", Caption)
        Loop Until AOLChild = 0
    End If
End Function

Public Function FindRoom(Optional strSend As String = vbNullString) As Long
    Dim AOLChild As Long
    Dim RICHCNTL As Long
    Dim AOLComboBox As Long
    Dim AOLListbox As Long
    AOLChild = FindAOLChild
    RICHCNTL = FindWindowEx(AOLChild, 0, "RICHCNTL", vbNullString)
    RICHCNTL = FindWindowEx(AOLChild, RICHCNTL, "RICHCNTL", vbNullString)
    AOLComboBox = FindWindowEx(AOLChild, 0, "_AOL_Combobox", vbNullString)
    AOLListbox = FindWindowEx(AOLChild, 0, "_AOL_Listbox", vbNullString)
    If RICHCNTL <> 0 And AOLComboBox <> 0 And AOLListbox <> 0 Then
        FindRoom = AOLChild
        If strSend > vbNullString Then
            Call SendMessageByString(RICHCNTL, WM_SETTEXT, 0, strSend)
            Call SendMessageLong(RICHCNTL, WM_CHAR, VK_RETURN, 0)
            Exit Function
        End If
        Exit Function
    Else
        Do
            DoEvents
            AOLChild = FindAOLChild(AOLChild)
            RICHCNTL = FindWindowEx(AOLChild, 0, "RICHCNTL", vbNullString)
            RICHCNTL = FindWindowEx(AOLChild, RICHCNTL, "RICHCNTL", vbNullString)
            AOLComboBox = FindWindowEx(AOLChild, 0, "_AOL_Combobox", vbNullString)
            AOLListbox = FindWindowEx(AOLChild, 0, "_AOL_Listbox", vbNullString)
            If RICHCNTL <> 0 And AOLComboBox <> 0 And AOLListbox <> 0 Then
                FindRoom = AOLChild
                If strSend > vbNullString Then
                    Call SendMessageByString(RICHCNTL, WM_SETTEXT, 0, strSend)
                    Call SendMessageLong(RICHCNTL, WM_CHAR, VK_RETURN, 0)
                    Exit Function
                End If
                Exit Function
            End If
        Loop Until AOLChild = 0
    End If
    FindRoom = AOLChild
End Function

Public Function FindWelcome() As Long
    Dim AOLChild As Long
    Dim strTemp As String
    AOLChild = FindAOLChild
    strTemp = GetCaption(AOLChild)
    If Left(strTemp, 9) = "Welcome, " Then
        FindWelcome = AOLChild
    Else
        Do
            DoEvents
            AOLChild = FindAOLChild(AOLChild)
            strTemp = GetCaption(AOLChild)
            If Left(strTemp, 9) = "Welcome, " Then
                Exit Do
            End If
        Loop Until AOLChild = 0
    End If
    FindWelcome = AOLChild
End Function

Public Sub FormDrag(TheForm As Form)
  ' DoS32.bas by к (xdosx@hotmail.com)
    Call ReleaseCapture
    Call SendMessage(TheForm.hWnd, WM_SYSCOMMAND, WM_MOVE, 0)
End Sub

Public Sub FormNotOnTop(FormName As Form)
  ' DoS32.bas by к (xdosx@hotmail.com)
    Call SetWindowPos(FormName.hWnd, HWND_NOTOPMOST, 0&, 0&, 0&, 0&, FLAGS)
End Sub

Public Sub FormOnTop(FormName As Form)
  ' DoS32.bas by к (xdosx@hotmail.com)
    Call SetWindowPos(FormName.hWnd, HWND_TOPMOST, 0&, 0&, 0&, 0&, FLAGS)
End Sub

Public Function GetCaption(WindowHandle As Long) As String
  ' DoS32.bas by к (xdosx@hotmail.com)
    Dim Buffer As String, TextLength As Long
    TextLength& = GetWindowTextLength(WindowHandle&)
    Buffer$ = String(TextLength&, 0&)
    Call GetWindowText(WindowHandle&, Buffer$, TextLength& + 1)
    GetCaption$ = Buffer$
End Function

Public Function GetFromINI(Section As String, key As String, Directory As String) As String
  ' DoS32.bas by к (xdosx@hotmail.com)
    Dim strBuffer As String
    strBuffer = String(750, Chr(0))
    key$ = LCase$(key$)
    GetFromINI$ = Left(strBuffer, GetPrivateProfileString(Section$, ByVal key$, "", strBuffer, Len(strBuffer), Directory$))
End Function

Public Function GetUser() As String
'    Dim AOLChild As Long
'    Dim strTemp As String
'    Dim strSplit() As String
'    AOLChild = FindWelcome
'    If AOLChild = 0 Then
'        GetUser = vbNullString
'        Exit Function
'    End If
'    strTemp = GetCaption(AOLChild)
'    strSplit = Split(strTemp, ", ")
'    strTemp = strSplit(UBound(strSplit))
'    strTemp = Left(strTemp, Len(strTemp) - 1)
'    GetUser = strTemp
    GetUser = "x"
End Function

Public Sub Pause(MilliSeconds As Long)
    Dim Current As Long
    Current = timeGetTime
    Do Until timeGetTime - Current >= MilliSeconds
        DoEvents
    Loop
End Sub

Public Sub PrivateRoom(RoomName As String)
    Dim AOLFrame25 As Long
    Dim AOLToolBar1 As Long
    Dim AOLToolBar2 As Long
    Dim AOLComboBox As Long
    Dim AOLEdit As Long
    AOLFrame25 = FindWindow("AOL Frame25", vbNullString)
    AOLToolBar1 = FindWindowEx(AOLFrame25, 0, "AOL Toolbar", vbNullString)
    AOLToolBar2 = FindWindowEx(AOLToolBar1, 0, "_AOL_Toolbar", vbNullString)
    AOLComboBox = FindWindowEx(AOLToolBar2, 0, "_AOL_Combobox", vbNullString)
    AOLEdit = FindWindowEx(AOLComboBox, 0, "Edit", vbNullString)
    Call SendMessageByString(AOLEdit, WM_SETTEXT, 0, "aol://2719:2-2-" & RoomName)
    Call SendMessageLong(AOLEdit, WM_CHAR, VK_SPACE, 0)
    Call SendMessageLong(AOLEdit, WM_CHAR, VK_RETURN, 0)
End Sub

Public Function strAdvertise() As String
    strAdvertise = "< A HREF=" & Chr(34) & "mailto:autofade@hotmail.com>Lox Buster v" & CStr(App.Major) & "." & CStr(App.Minor) & "." & CStr(App.Revision) & " Request A Copy</A>"
End Function

Public Function ValidateText(ByVal pKeyIn As Integer, ByVal pValidateString As String, ByVal pEditable As Boolean) As Integer
  ' Pure Visual Basic - Dan Fox
    Dim strValidateList  As String
    Dim intKeyOut As Integer
    If pEditable Then
        strValidateList = UCase(pValidateString) & Chr(8)
    Else
        strValidateList = UCase(pValidateString)
    End If
    If InStr(1, strValidateList, UCase(Chr(pKeyIn)), 1) > 0 Then
        intKeyOut = pKeyIn
    Else
        intKeyOut = 0
        Beep
    End If
    ValidateText = intKeyOut
End Function

Public Sub WriteToINI(Section As String, key As String, KeyValue As String, Directory As String)
  ' DoS32.bas by к (xdosx@hotmail.com)
    Call WritePrivateProfileString(Section$, UCase$(key$), KeyValue$, Directory$)
End Sub
